Kea: isc::dhcp::ClientClassDefListParser Class Reference

| Kea 2.2.0

Public Member Functions | List of all members
isc::dhcp::ClientClassDefListParser Class Reference

Parser for a list of client class definitions. More...

`#include <client_class_def_parser.h>`

Inheritance diagram for isc::dhcp::ClientClassDefListParser:
[legend]

## Public Member Functions
ClientClassDictionaryPtr | parse (isc::data::ConstElementPtr class_def_list, uint16_t family, bool check_dependencies=true)
| Parse configuration entries. More...
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t. More...
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t. More...
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value. More...
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet. More...

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type. More...
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present. More...
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child. More...
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope. More...
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope. More...
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range. More...
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element. More...
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope. More...
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values. More...
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list. More...
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type , target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope. More...
template<typename int_type >
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope. More...

## Detailed Description

Parser for a list of client class definitions.

This parser iterates over all configuration entries that define client classes and creates ClientClassDef instances for each. When the parsing successfully completes, the collection of created definitions is given to the CfgMgr.

Definition at line 150 of file client_class_def_parser.h.

## Member Function Documentation

## ◆ parse()

ClientClassDictionaryPtr isc::dhcp::ClientClassDefListParser::parse | ( | isc::data::ConstElementPtr | class_def_list,
|  | uint16_t | family,
|  | bool | check_dependencies = `true`
| ) |  |

Parse configuration entries.

This function parses configuration entries, creates instances of client class definitions and tries to adds them to the local dictionary. At the end the dictionary is returned.

Parameters

  class_def_list | pointer to an element that holds entries for client class definitions.
  family | the address family of the client class definitions.
  check_dependencies | indicates if the parser should evaluate an expression to see if the referenced client classes exist.

Returns
  a pointer to the filled dictionary

Exceptions

  DhcpConfigError | if configuration parsing fails.

Definition at line 313 of file client_class_def_parser.cc.

References isc::dhcp::ClientClassDefParser::parse().

Referenced by isc::dhcp::configureDhcp4Server(), and isc::dhcp::configureDhcp6Server().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- client_class_def_parser.h
- client_class_def_parser.cc